--- old/usr/src/uts/common/fs/zfs/dsl_dataset.c	Tue Oct  1 14:04:31 2013
+++ new/usr/src/uts/common/fs/zfs/dsl_dataset.c	Tue Oct  1 14:04:31 2013
@@ -352,7 +352,7 @@
 
 	/* Make sure dsobj has the correct object type. */
 	dmu_object_info_from_db(dbuf, &doi);
-	if (doi.doi_type != DMU_OT_DSL_DATASET) {
+	if (doi.doi_bonus_type != DMU_OT_DSL_DATASET) {
 		dmu_buf_rele(dbuf, tag);
 		return (SET_ERROR(EINVAL));
 	}
@@ -2971,4 +2971,12 @@
 	ret = dsl_dataset_is_before(origin, earlier);
 	dsl_dataset_rele(origin, FTAG);
 	return (ret);
+}
+
+
+void
+dsl_dataset_zapify(dsl_dataset_t *ds, dmu_tx_t *tx)
+{
+	objset_t *mos = ds->ds_dir->dd_pool->dp_meta_objset;
+	dmu_object_zapify(mos, ds->ds_object, DMU_OT_DSL_DATASET, tx);
 }
